
!------------------------RECURSION START----------------------

	recursive Subroutine rekurz(S,D,NR,SP,speed)
	
	USE MSFLIB

	implicit real*8 (b-h,j-z)
	!TT=parameter T for the nearest hit sphere
	!HIT=number of the sphere that was hit first
	!DI=discriminant of quadratic equation for ray and sphere iontersection
	!K1,K2,K3=constants a,b,c of quadratic equation for ray and sphere iontersection

	implicit integer(2) (A)

	dimension S(3),D(3),C1(4),T(3),A(3),B(3),E(3)
	dimension EL(3),EC(3),CDV(3),NDV(3),SP(10,4),nR(10)
	!E=EndPoint of line
	!SP=data for 5 spheres
	!A=start point of line to draw
	!B=end point of line to draw
	!S=Start point of line
	!D=Direction of line
	!C1=Circle1 data
	!LL=line lenght
	!T=parameter for vector line notation
	!EL=unit vector in line direction
	!EC=unit vector in circle radius directio	
	!cosfi=cosine of the angle between EL and EC
	!CDV=change-of-direction vector
	!NDV=new-direction vector
	!NR=number-of-reflections per surface

	TYPE (xycoord) xy

	!Setting the parameter KONEC, which says when to end program
	konec=0

	!Norming the direction vector
	LL=sqrt(D(1)**2+D(2)**2+D(3)**2)
	D=(/(D(i)/LL,i=1,3)/)

	!Intersection of line and sphere
	TT=1e9
	do m=1,5
		if (nr(m).lt.1)then
			goto 160
		endif
		WW=0
		c1=(/(sp(m,i),i=1,4)/)

		K1=0
		K2=0
		K3=0
		do i=1,3
			 K1=K1+D(i)**2
			 K2=K2+2*S(i)*D(i)-2*D(i)*C1(i)
			 K3=K3+S(i)**2+c1(i)**2-2*S(i)*C1(i)
		enddo
	
		K3=K3-c1(4)**2
		DI=K2**2-4*K1*K3
	
		if(DI.lt.0) then
				T(3)=1e8
				goto 150
		endif

		t1=(-K2+sqrt(DI))/2/K1
		t2=(-K2-sqrt(DI))/2/K1
		if (t2.gt.0) then
				t(3)=t2
			else if (t1.gt.0) then
				t(3)=t1
			else
				T(3)=1e8
				goto 150
		endif

		goto 150

		!Defining the nearest hit sphere
150		if(T(3).lt.TT)then
			TT=T(3)
			HIT=m
		endif
	
160	enddo

	!Decrease the NR for the hit sphere by one
	NR(hit)=nr(hit)-1
	
	!Generate data for the nearest hit sphere
	T(3)=TT
	E=(/(S(i)+T(3)*D(i),i=1,3)/)
	c1=(/(sp(hit,i),i=1,4)/)

	!Check if enpoint of line lies within view window (800x600)
	if ((E(1)>800).or.(E(1)<1).or.(E(3)<1).or.(E(3)>600)) then
		tt=1e7
	endif
	
	!If no sphere is hit, calculate ray path
170	if(tt.gt.1e6)then
		E=(/(S(i),i=1,3)/)
		t(3)=0
		do while((e(1).le.800).and.(e(1).ge.0).and.(e(3).ge.0).and.(e(3).le.600))
			t(3)=t(3)+1
			E=(/(S(i)+T(3)*D(i),i=1,3)/) 
		enddo
		konec=1
	endif

	!Draw line from the last hit sphere to destination
	A=(/(int(s(i)),i=1,3)/)
	CALL MOVETO(A(1),A(3),xy)
	do j=1,speed
		B=(/(int(s(i)+t(3)*j*d(i)/speed),i=1,3)/)
		status = LINETO(B(1),B(3))
	enddo
	
	!End program if no spheres are hit to prevent it to
	!calculate new direction of line
	if (konec.eq.1) then
		goto 210
	endif

	!New direction of line when a sphere is hit
	EL=(/(-D(i),i=1,3)/)
	EC=(/((-C1(i)+E(i))/C1(4),i=1,3)/)
	cosfi=EL(1)*EC(1)+EL(2)*EC(2)+EL(3)*EC(3)
	do i=1,3
		CDV(i)=-EL(i)+cosfi*EC(i)
		NDV(i)=cosfi*EC(i)+CDV(i)
	enddo
	S=(/(E(i)+.1*NDV(i),i=1,3)/)	!x,y,z
	D=(/(NDV(i),i=1,3)/)			!x,y,z

	call rekurz(S,D,NR,SP,speed)

210	return
	end
!------------------------RECURSION END-------------------------

	





!-------------------------MAIN PROGRAM-------------------
	USE MSFLIB

	implicit real*8 (b-h,j-z)
	!XYZ=direction of viewpoint
	!SPEED=speed of line drawing
	!SX=Scaling factor for the x,y,z coordinates

	integer(4) color
	!NOS=number-of-spheres
	!NOR=number-of-rays
	
	dimension SP(10,4),sr(10,3),dr(10,3),SNR(10),S(3),D(3),nr(10),C11(4)
	dimension sp0(10,4),sr0(10,4),dr0(10,4),view(3,2),DX(3),axes(3)
	!SP=data for 5 spheres
	!SR=rays start point
	!DR=direction of rays
	!SNR=Starting number-of-reflections for each sphere
	!C11=Circle1 data for drawing
	!NR=number-of-reflections per surface
	!scale=minimum and maximum coordinate of the coordinates of the viewport
	!DX=moving constant for the x,y,z coordinates
	!axes=sequence of axes


	character*12 filename
	character*1 axis1,axis2
	!filename=name of the file to import
	!axis1,2=name of the axes

	TYPE (windowconfig) wc
	LOGICAL status /.FALSE./

	!Defining the default values
	SNR=(/(9999.,i=1,10)/)
	speed=5000

	!Set the background color
	bkcolor=SETBKCOLORRGB(#FFFFFF) !White
	CALL CLEARSCREEN($GCLEARSCREEN)

	!Set the color of the text
	color = SETTEXTCOLORRGB(#000000) !Black


	!-----------------------DATA INPUT-----------------
	!Welcome screen
100	CALL CLEARSCREEN($GCLEARSCREEN)
	write(*,*)
	write(*,*)'                                         ACOTRACE'
	write(*,*)
	write(*,*)'                 A program for drawing the reflection of a beam of light'
	write(*,*)'                              between sheres, placed in space.'
	write(*,*)
	write(*,*)'                                    by Gustin Bostjan'
	write(*,*)
	write(*,*)'-------------------------------------------------------------------------------'
	write(*,*)
	write(*,*)'Do you want to input the data from a FILE or by TYPING?'
	write(*,*)'(1=FILE,2=TYPING)?'
	read(*,*)yn
	
	!File Data import
	if (yn.eq.1) then
		write(*,*)'File name?'	
		read(*,*)filename
		open(13,file=filename)
		read(13,*)speed
		read(13,*)nor
		read(13,*)((SR(i,j),j=1,3),i=1,NOR)
		read(13,*)((DR(i,j),j=1,3),i=1,NOR)
		read(13,*)nos
		read(13,*)((SP(i,j),j=1,4),i=1,NOS)
		read(13,*)(SNR(i),i=1,nos)
		goto 140
	endif

	!Typing data input
110	write(*,*)'How many spheres do you want (1-10)?'
	read(*,*)nos
	nos=int(nos)
	if(nos.gt.10) then
		write(*,*)'Number is not within range'
		goto 110
	endif
	write(*,*)'Write the data for the spheres (x,y,z,r)'
	read(*,*)((sp(i,j),j=1,4),i=1,nos)
120	write(*,*)'How many rays do you want (1-10)?'
	read(*,*)nor
	nor=int(nor)
	if(nor.gt.10) then
		write(*,*)'Number is not within range'
		goto 120
	endif
	write(*,*)'Write the data for the START POINTS of the RAYS (x,y,z)'
	read(*,*)((sr(i,j),j=1,3),i=1,nor)
	write(*,*)'Write the data for the DIRECTION VECTORS of the RAYS (x,y,z)'
	read(*,*)((dr(i,j),j=1,3),i=1,nor)

	
	!Options input
140	write(*,*)'Do you want to change the OPTIONS (1=YES,2=NO)?'
	read(*,*)yn
	if (yn.ne.1) then
		goto 150
	endif
	write(*,*)'Do you want to define the maximum Number-of-Reflections (NR) for each sphere'
	write(*,*)'(1=YES,2=NO)?'
	read(*,*)yn
	if (yn.eq.1) then
		write(*,*)'Write the maximum Number-of-Reflections (NR) for each sphere (NR1,NR2,..,NR10)'
		read(*,*)(SNR(i),i=1,nos)
	endif
	write(*,*)'Write the smoothig-of-drawing factor (ca.2000)'
	read(*,*)speed
	write(*,*)'Do you want to change the viewport'
	write(*,*)'(1=YES,2=NO)?'
	read(*,*)yn
	if (yn.ne.1) then
		goto 150
	endif
130	write(*,*)'Which axis do you want to put the viewpoint above (X=1,Y=2,Z=3)'
	read(*,*)XYZ
	if (xyz.eq.1) then
		axis1='Z'
		axis2='Y'
		axes=(/3,1,2/)
	else if(xyz.eq.2) then
		axis1='X'
		axis2='Z'
		axes=(/1,2,3/)
	else if(xyz.eq.3) then
		axis1='Y'
		axis2='X'
		axes=(/2,3,1/)
	else				
		write(*,*)'Number is not within range'
		goto 130
	endif			
	write(*,*)axis1,' points RIGHT, ',axis2,' points DOWN'
	write(*,*)'Write the MIN and MAX value of the ',axis1,'(horizontal) coord. of the viewport(min,max)'
	read(*,*)(view(1,i),i=1,2)
	write(*,*)'Write the MIN value of the ',axis2,'(vertical) coord. of the viewport'
	read(*,*)view(3,1)
	pause

	!-----------------------END OF DATA INPUT-----------------


	!Converting coordinates into screen coord.
	SX=800/(view(1,2)-view(1,1))
	!view(axe(2),2)=view(axe(2),1)+800/SX
	do i=1,10
		do j=1,4
			sp0(i,j)=sp(i,j)
			sr0(i,j)=sr(i,j)
			dr0(i,j)=dr(i,j)
		enddo
	enddo

	DO I=1,3
		DX(i)=-view(i,1)
		do j=1,10
			sp(j,i)=int((sp0(j,axes(i))+dx(i))*SX)
			sr(j,i)=int((sr0(j,axes(i))+dx(i))*SX)
			dr(j,i)=dr0(j,axes(i))
		enddo
	enddo

	do i=1,10
		sp(i,4)=sp0(i,4)*SX
	enddo

	!Start-up graphic routines
		!Set the graphics mode
		!Set the x & y pixels to 800X600 and font size to 8x12
150		wc.numxpixels = 800
		wc.numypixels = 600
		wc.numtextcols = -1
		wc.numtextrows = -1
		wc.numcolors = -1
		wc.title= "ACOTRACE"C
		wc.fontsize = #0008000C
		if (.NOT.status) status = SETWINDOWCONFIG(wc)

		!Fill with the background color
		bkcolor=FLOODFILLRGB(100,100,#FFFFFF)

		!Set the color of the spheres
		color = SETCOLORRGB(#000000) !Black

		!Draw the spheres
		do i=1,nos
			do j=1,3
				if(j.eq.1) then
					k=1.
					m=1.
				else if (j.eq.2) then
					k=.15
					m=1.
				else if (j.eq.3) then
					k=1.
					m=.3
				endif
			C11=(/sp(i,1)-k*SP(i,4),SP(i,3)-m*SP(i,4),SP(i,1)+k*SP(i,4),SP(i,3)+m*SP(i,4)/)	!x1,y1,x2,y2
			dummy = ELLIPSE($GBORDER,C11(1),C11(2),C11(3),C11(4))
			enddo
		enddo

		!Set the color of the rays
		color = SETCOLORRGB(#0000FF) !Red
	
	!Defining current ray
	do n=1,nor
		D=(/(DR(n,i),i=1,3)/)
		S=(/(SR(n,i),i=1,3)/)
		NR=(/(SNR(i),i=1,10)/)

		CALL rekurz(S,D,NR,SP,speed)

200	enddo

300	end
